<template>
  <l-map
    style="height: 300px"
    :zoom="zoom"
    :center="center"
    @update:zoom="zoomUpdated"
  >
    <l-control class="marker-list-control">
      <div>
        <ObjectControl
          :objects="data"
          :selected-object="selectedMarker"
          @ObjectSelected="OnObjectSelected($event)"
        />
      </div>
    </l-control>
    <l-tile-layer :url="url" :attribution="attribution"></l-tile-layer>
    <l-marker
      v-for="marker in data"
      :key="marker.id"
      :lat-lng="[marker.latitude, marker.longitude]"
      @click="clickOnMarker(marker.id)"
      @ObjectSelected="OnObjectSelected"
      :icon="getIcon(marker.id)"
    >
    </l-marker>
  </l-map>
</template>

<script>
import { LMap, LTileLayer, LMarker, LControl } from "vue2-leaflet";
import json from "../data.json";
import { Icon, divIcon } from "leaflet";
import ObjectControl from "./ObjectControl.vue";

export default {
  components: {
    LMap,
    LTileLayer,
    LMarker,
    LControl,
    ObjectControl,
  },
  data() {
    return {
      url: "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",
      attribution:
        '&copy; <a target="_blank" href="http://osm.org/copyright">OpenStreetMap</a> contributors',
      zoom: 3,
      center: [51.505, -0.159],
      data: json,
      selectedMarker: null,
    };
  },
  methods: {
    clickOnMarker(id) {
      this.selectedMarker = id;
      this.showSelectedPoint();
    },
    OnObjectSelected(id) {
      this.selectedMarker = id;
      this.showSelectedPoint();
    },
    getIcon(id) {
      let color = this.selectedMarker === id ? "#ff3300" : "#0099ff";
      let strokeColor = this.selectedMarker === id ? "#ff0000" : "#0066ff";
      let circleColor = this.selectedMarker === id ? "#cc0000" : "#0033cc";
      return divIcon({
        className: "my-custom-pin",
        iconUrl: "",
        html: `<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 34.892337" height="50" width="30">
  <g transform="translate(-814.59595,-274.38623)">
    <g transform="matrix(1.1855854,0,0,1.1855854,-151.17715,-57.3976)">
      <path d="m 817.11249,282.97118 c -1.25816,1.34277 -2.04623,3.29881 -2.01563,5.13867 0.0639,3.84476 1.79693,5.3002 4.56836,10.59179 0.99832,2.32851 2.04027,4.79237 3.03125,8.87305 0.13772,0.60193 0.27203,1.16104 0.33416,1.20948 0.0621,0.0485 0.19644,-0.51262 0.33416,-1.11455 0.99098,-4.08068 2.03293,-6.54258 3.03125,-8.87109 2.77143,-5.29159 4.50444,-6.74704 4.56836,-10.5918 0.0306,-1.83986 -0.75942,-3.79785 -2.01758,-5.14062 -1.43724,-1.53389 -3.60504,-2.66908 -5.91619,-2.71655 -2.31115,-0.0475 -4.4809,1.08773 -5.91814,2.62162 z" style="fill:${color};stroke:${strokeColor};"/>
      <circle r="3.0355" cy="288.25278" cx="823.03064" id="path3049" style="display:inline;fill:${circleColor};"/>
    </g>
  </g>
</svg>`,
      });
    },
    showSelectedPoint() {
      const point = this.data.find((point) => point.id === this.selectedMarker);
      if (point) {
        this.center = [point.latitude, point.longitude];
        setTimeout(() => {
          this.zoom = 8;
        }, 400);
      }
    },
    zoomUpdated(zoom) {
      this.zoom = zoom;
    },
  },
  mounted() {
    delete Icon.Default.prototype._getIconUrl;
    Icon.Default.mergeOptions({
      iconRetinaUrl: require("leaflet/dist/images/marker-icon-2x.png"),
      iconUrl: require("leaflet/dist/images/marker-icon.png"),
      shadowUrl: require("leaflet/dist/images/marker-shadow.png"),
    });
  },
};
</script>
<style scoped>
@import "~leaflet/dist/leaflet.css";
</style>